/**********************************************************************\
* Dateiname: charstt1.cpp
* Autor    : Jesorsky
* Projekt  : Programmieruebung
*
* Kurzbeschreibung: Diese Datei enthaelt das Testprogramm fuer die 
* Klasse CharSet (ausfuehrliche Beschreibung in charset.htm).
*
* Datum:     Autor:      Grund der Aenderung:
* 24.09.1999 Jesorsky    Neuerstellung
* 25.10.2000 Jesorsky    Alle Objekte "const".
\**********************************************************************/

/*--- #includes der Form <...> ---------------------------------------*/

#include <stdio.h>

/*--- #includes der Form "..." ---------------------------------------*/

#include "charset1.hpp"

/*--- #define-Konstanten und Makros ----------------------------------*/

#define PRINTSET(par)  (printf("%s", #par " = "), (par).print(), \
	printf("\n"))
#define PRINTBOOL(par) (printf("%s%d\n", #par " = ", (par)))

int main(void)
{
	CharSet cs1, cs2, cs3, cs4;

	cs1.init("ABCX");
	cs2.init("CDY");
	cs3.init("BC");
	cs4.init("ABCX");

	PRINTSET(cs1);
	PRINTSET(cs2);
	PRINTSET(cs3);
	PRINTSET(cs4);
	PRINTSET(cs1 + cs2);
	PRINTSET(cs1 * cs2);
	PRINTSET(cs1 - cs2);
	PRINTBOOL(cs1.contains('B'));
	PRINTBOOL(cs1.contains('D'));
	PRINTBOOL(cs2.contains('D'));
	PRINTBOOL(cs1 == cs2);
	PRINTBOOL(cs1 == cs4);
	PRINTBOOL(cs1 != cs2);
	PRINTBOOL(cs2 <= cs1);
	PRINTBOOL(cs3 <= cs1);
	PRINTBOOL(cs1 >= cs3);
	return 0;
}

/* Ausgabe:
------------------------------------------------------------------------
cs1 = ABCX
cs2 = CDY
cs3 = BC
cs4 = ABCX
cs1 + cs2 = ABCDXY
cs1 * cs2 = C
cs1 - cs2 = ABX
cs1.contains('B') = 1
cs1.contains('D') = 0
cs2.contains('D') = 1
cs1 == cs2 = 0
cs1 == cs4 = 1
cs1 != cs2 = 1
cs2 <= cs1 = 0
cs3 <= cs1 = 1
cs1 >= cs3 = 1
----------------------------------------------------------------------*/