/**********************************************************************\
* Dateiname: charstt2.cpp
* Autor    : Jesorsky
* Projekt  : Programmieruebung
*
* Kurzbeschreibung: Diese Datei enthaelt das Testprogramm fuer die 
* Klasse CharSet (ausfuehrliche Beschreibung in charset.htm).
*
* Datum:     Autor:      Grund der Aenderung:
* 24.09.1999 Jesorsky    Neuerstellung
* 25.10.2000 Jesorsky    Alle Objekte "const".
\**********************************************************************/

/*--- #includes der Form <...> ---------------------------------------*/

#include <iostream>
using namespace std;

/*--- #includes der Form "..." ---------------------------------------*/

#include "charset2.hpp"

/*--- #define-Konstanten und Makros ----------------------------------*/

#define COUT(par) (cout << #par " = " << (par) << '\n')

int main(void)
{
	const CharSet cs1("ABCX");
	const CharSet cs2("CDY");
	const CharSet cs3("BC");
	const CharSet cs4(cs1);

	COUT(cs1);
	COUT(cs2);
	COUT(cs3);
	COUT(cs4);
	COUT(cs1 + cs2);
	COUT(cs1 * cs2);
	COUT(cs1 - cs2);
	COUT(cs1.contains('B'));
	COUT(cs1.contains('D'));
	COUT(cs2.contains('D'));
	COUT(cs1 == cs2);
	COUT(cs1 == cs4);
	COUT(cs1 != cs2);
	COUT(cs2 <= cs1);
	COUT(cs3 <= cs1);
	COUT(cs1 >= cs3);
	return 0;
}

/* Ausgabe:
------------------------------------------------------------------------
cs1 = ABCX
cs2 = CDY
cs3 = BC
cs4 = ABCX
cs1 + cs2 = ABCDXY
cs1 * cs2 = C
cs1 - cs2 = ABX
cs1.contains('B') = 1
cs1.contains('D') = 0
cs2.contains('D') = 1
cs1 == cs2 = 0
cs1 == cs4 = 1
cs1 != cs2 = 1
cs2 <= cs1 = 0
cs3 <= cs1 = 1
cs1 >= cs3 = 1
----------------------------------------------------------------------*/