/**********************************************************************\
* Dateiname: tcont.c
* Autor    : Jesorsky
* Projekt  : Programmieruebung
*
* Kurzbeschreibung: Diese Datei enthaelt das Testprogramm fuer eine 
* Programmieruebung, in der ein gekapselter Container fuer Objekte des
* Typs T entwickelt werden soll (ausfuehrliche Beschreibung in 
* Cont1.txt).
*
* Datum:     Autor:      Grund der Aenderung:
* 24.09.1999 Jesorsky    Neuerstellung
\**********************************************************************/

/*--- #includes der Form <...> ---------------------------------------*/

#include <stdio.h>

/*--- #includes der Form "..." ---------------------------------------*/

#include "t.h"
#include "tcon.h"

/*--- #define-Konstanten und Makros ----------------------------------*/

/*--- Datentypen (typedef) -------------------------------------------*/

/*--- Globale Konstanten ---------------------------------------------*/

/*--- Globale Variablen ----------------------------------------------*/

/*--- Modullokale Konstanten -----------------------------------------*/

/*--- Modullokale Variablen ------------------------------------------*/

/*--- Prototypen modullokaler Funktionen -----------------------------*/

/*--- Funktionsdefinitionen ------------------------------------------*/

int main(void)
{
	char cmd;          /* Funktionsauswahl                             */
	T buffer;          /* Zwischenspeicherung eines Container-Elements */
	T *pElem;          /* Iterieren ueber alle Container-Elemente      */

	/* Test der assert() Aufrufe:
	"Entkommentieren" Sie jeweils eine der folgenden Anweisungen
	und ueberpruefen Sie auf diese Weise, ob die unzulssigen
	Funktionsaufrufe entdeckt werden und das Programm mit einer
	entsprechenden Fehlermeldung abgebrochen wird:
	*/

	/* pop_front(); */
	/* pop_back();  */
	/* front();     */
	/* back();      */

	do                          /* solange, bis Funktion quit gewaehlt */
	{
		printf("1=push_front 2=push_back 3=pop_front 4=pop_back "
			"5=front 6=back 7=show q=quit: ");
		fflush(stdin);
		cmd = getchar();
		switch (cmd)
		{
		case '1':
			printf("push_front, ");
			scanT(&buffer);
			push_front(&buffer);
			break;

		case '2':
			printf("push_back, ");
			scanT(&buffer);
			push_back(&buffer);
			break;

		case '3':
			if (!empty())
				pop_front();
			else
				printf("---Container leer---\n");
			break;

		case '4':
			if (!empty())
				pop_back();
			else
				printf("---Container leer---\n");
			break;

		case '5':
			if (!empty())
			{
				printf("front:\n");
				printT(front());
			}
			else
				printf("---Container leer---\n");
			break;

		case '6':
			if (!empty())
			{
				printf("back:\n");
				printT(back());
			}
			else
				printf("---Container leer---\n");
			break;

		case '7':
			printf("show:\n");
			for (pElem = begin(); pElem != end(); pElem = next(pElem))
				printT(pElem);
			break;

		case 'q':
			break;

		default:
			printf("unerlaubtes Zeichen\n");
		}
	} while (cmd != 'q');
	return 0;
}

/* Ein-/Ausgabe (eine von vielen moeglichen):
-------------------------------------------------------------------------------
1=push_front 2=push_back 3=pop_front 4=pop_back 5=front 6=back 7=show q=quit: 1
push_front, int-Zahl: 11
1=push_front 2=push_back 3=pop_front 4=pop_back 5=front 6=back 7=show q=quit: 1
push_front, int-Zahl: 22
1=push_front 2=push_back 3=pop_front 4=pop_back 5=front 6=back 7=show q=quit: 2
push_back, int-Zahl: 99
1=push_front 2=push_back 3=pop_front 4=pop_back 5=front 6=back 7=show q=quit: 7
show:
22
11
99
1=push_front 2=push_back 3=pop_front 4=pop_back 5=front 6=back 7=show q=quit: q
-----------------------------------------------------------------------------*/