#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>

#include "t.h"
#include "tconarr2.hpp"

void Tcont::push_front(const T &pItem) //Fuegt pItem an Anfang des Containers
{
	int cap_help = 0;
	int size_help = 0;

	if (count == capacity)
	{
		capacity = capacity + array_size;
		cap_help = capacity * sizeof(T);
		pData = (T *)realloc(pData, cap_help);
		checkMem(pData);
	}
	else
		;

	size_help = (count++) * sizeof(T);
	memcpy((pData + 1), pData, size_help);

	pData[0] = pItem;
}

void Tcont::pop_front(void) //Entfernt 1. Containerobj.
{
	int size_help = 0;

	assert(count != 0);

	size_help = (count--) * sizeof(T);
	memcpy(pData, (pData + 1), size_help);
}

void Tcont::push_back(const T &pItem) //Fuegt pItem ans Ende des Cont. an
{
	int cap_help = 0;

	if (count == capacity)
	{
		capacity = capacity + array_size;
		cap_help = capacity * sizeof(T);
		pData = (T *)realloc(pData, cap_help);
		checkMem(pData);
	}
	pData[count++] = pItem;
}

void Tcont::pop_back() //Entf. letztes Cont. Obj.
{
	assert(count != 0);

	count--;
}

T &Tcont::front() const //1. Cont. Obj.
{
	assert(count != 0);

	return pData[0]; //return pData;
}

T &Tcont::back() const //Letztes Cont. Obj.
{
	//T *back;

	assert(count != 0);

	//back = pData + count - 1;
	//back = pData[count - 1];
	//return back;
	return pData[count - 1];
}

bool Tcont::empty() const //Cont. leer?
{
	//if (count == 0)
	//	return 1;
	//else
	//	return 0;
	return count == 0;
}

Tcont::iterator Tcont::begin() const //Iterator auf 1. Cont. Obj.
{
	/*if (count == 0)
	return pData + count;
	else
	return pData;*/
	return iterator(pData);
}

Tcont::iterator Tcont::end() const //Iterator auf letztem Cont. Obj.
{
	/*T *end;
	end = pData + count;
	return end;*/
	return iterator(pData + count);
}

void Tcont::checkMem(void *pv) //Beendet Prog., falls NULL-Zgr.
{
	if (pv == NULL)
	{
		fprintf(stderr, "Out Of Memory\n");
		exit(1);
	}
}

Tcont::Tcont() //Konstruktor --> Cont.-Obj. wird erzeugt
{
	count = 0;
	capacity = 0;
	pData = NULL;
}

Tcont::~Tcont() //Destruktor --> Gibt Cont.-Obj. frei
{
	free(pData);
}

Tcont::iterator::iterator(T *pElement) //Konstruktor
{
	pElem = pElement;
}

Tcont::iterator Tcont::iterator::operator++(int) //Inkrement-Operator --> fuer "T *Tcont::next"
{
	//return pItem + 1;
	return iterator(pElem++);
}

T &Tcont::iterator::operator*() const //Dereferenzierungsoperator
{
	return *pElem;
}

bool Tcont::iterator::operator!=(const iterator &it) const //Vergleichsoperator
{
	return pElem != it.pElem;
}