/**********************************************************************\
* Dateiname: gerdatet.cpp
* Autor    : Jesorsky
* Projekt  : Programmieruebung
*
* Kurzbeschreibung: Diese Datei enthaelt das Testprogramm fuer die 
* Klassen Date und GermanDate (ausfuehrliche Beschreibung in 
* GerDate.txt).
*
* Datum:     Autor:      Grund der Aenderung:
* 24.09.1999 Jesorsky    Neuerstellung
* 09.12.2003 Jesorsky    C++ Includes ohne ".h" --> namespace std
\**********************************************************************/

/*--- #includes der Form <...> ---------------------------------------*/

#include <iostream>
using namespace std;

/*--- #includes der Form "..." ---------------------------------------*/

#include "date.hpp"
#include "gerdate.hpp"


int main(void)
{
	GermanDate gd(27, 11, 1999);
	const GermanDate cgd(gd);
	Date d(gd);
	const Date cd(d);

	cout << "Datum: " << d << endl; //(endl: Terminates a line and flushes the buffer)
	cout << "Datum: " << cd << endl;

	cout << "Datum (Kurzform): " << gd << endl;
	cout << "Datum (Kurzform): " << cgd << endl;
	GermanDate::setLongFormat();
	cout << "Datum (Langform): " << gd << endl;
	cout << "Datum (Langform): " << cgd << endl;

	return 0;
}

/* Ausgabe:
------------------------------------------------------------------------
Datum: 11/27/1999
Datum: 11/27/1999
Datum (Kurzform): 27.11.1999
Datum (Kurzform): 27.11.1999
Datum (Langform): 27. November 1999
Datum (Langform): 27. November 1999
----------------------------------------------------------------------*/